Index: branches/5.6/tests/phpunit/tests/functions/wpRemoteFopen.php
===================================================================
--- branches/5.6/tests/phpunit/tests/functions/wpRemoteFopen.php	(revision 57454)
+++ branches/5.6/tests/phpunit/tests/functions/wpRemoteFopen.php	(revision 57995)
@@ -27,9 +27,9 @@
 	public function test_wp_remote_fopen() {
 		// This URL gives a direct 200 response.
-		$url      = 'https://asdftestblog1.files.wordpress.com/2007/09/2007-06-30-dsc_4700-1.jpg';
+		$url      = 'https://s.w.org/screenshots/3.9/dashboard.png';
 		$response = wp_remote_fopen( $url );
 
 		$this->assertInternalType( 'string', $response );
-		$this->assertSame( 40148, strlen( $response ) );
+		$this->assertSame( 153204, strlen( $response ) );
 	}
 }
Index: branches/5.6/tests/phpunit/tests/http/functions.php
===================================================================
--- branches/5.6/tests/phpunit/tests/http/functions.php	(revision 57454)
+++ branches/5.6/tests/phpunit/tests/http/functions.php	(revision 57995)
@@ -10,5 +10,5 @@
 	function test_head_request() {
 		// This URL gives a direct 200 response.
-		$url      = 'https://asdftestblog1.files.wordpress.com/2007/09/2007-06-30-dsc_4700-1.jpg';
+		$url      = 'https://s.w.org/screenshots/3.9/dashboard.png';
 		$response = wp_remote_head( $url );
 
@@ -19,6 +19,6 @@
 		$this->assertInternalType( 'array', $response );
 
-		$this->assertSame( 'image/jpeg', $headers['content-type'] );
-		$this->assertSame( '40148', $headers['content-length'] );
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
 		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
@@ -26,5 +26,5 @@
 	function test_head_redirect() {
 		// This URL will 301 redirect.
-		$url      = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+		$url      = 'https://wp.org/screenshots/3.9/dashboard.png';
 		$response = wp_remote_head( $url );
 
@@ -33,6 +33,9 @@
 	}
 
-	function test_head_404() {
-		$url      = 'https://asdftestblog1.files.wordpress.com/2007/09/awefasdfawef.jpg';
+	/**
+	 * @covers ::wp_remote_head
+	 */
+	public function test_head_404() {
+		$url      = 'https://wordpress.org/screenshots/3.9/awefasdfawef.jpg';
 		$response = wp_remote_head( $url );
 
@@ -41,6 +44,11 @@
 	}
 
-	function test_get_request() {
-		$url = 'https://asdftestblog1.files.wordpress.com/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_get
+	 * @covers ::wp_remote_retrieve_headers
+	 * @covers ::wp_remote_retrieve_response_code
+	 */
+	public function test_get_request() {
+		$url = 'https://s.w.org/screenshots/3.9/dashboard.png';
 
 		$response = wp_remote_get( $url );
@@ -53,12 +61,12 @@
 
 		// Should return the same headers as a HEAD request.
-		$this->assertSame( 'image/jpeg', $headers['content-type'] );
-		$this->assertSame( '40148', $headers['content-length'] );
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
 		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
 
 	function test_get_redirect() {
-		// This will redirect to asdftestblog1.files.wordpress.com.
-		$url = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+		// This will redirect to wordpress.org.
+		$url = 'https://wp.org/screenshots/3.9/dashboard.png';
 
 		$response = wp_remote_get( $url );
@@ -69,12 +77,12 @@
 
 		// Should return the same headers as a HEAD request.
-		$this->assertSame( 'image/jpeg', $headers['content-type'] );
-		$this->assertSame( '40148', $headers['content-length'] );
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
 		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
 
 	function test_get_redirect_limit_exceeded() {
-		// This will redirect to asdftestblog1.files.wordpress.com.
-		$url = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+		// This will redirect to wordpress.org.
+		$url = 'https://wp.org/screenshots/3.9/dashboard.png';
 
 		// Pretend we've already redirected 5 times.
Index: branches/5.6/tests/phpunit/tests/image/functions.php
===================================================================
--- branches/5.6/tests/phpunit/tests/image/functions.php	(revision 57454)
+++ branches/5.6/tests/phpunit/tests/image/functions.php	(revision 57995)
@@ -369,5 +369,5 @@
 	public function test_wp_crop_image_url() {
 		$file = wp_crop_image(
-			'https://asdftestblog1.files.wordpress.com/2008/04/canola.jpg',
+			'https://s.w.org/screenshots/3.9/dashboard.png',
 			0,
 			0,
@@ -377,5 +377,5 @@
 			100,
 			false,
-			DIR_TESTDATA . '/images/' . __FUNCTION__ . '.jpg'
+			DIR_TESTDATA . '/images/' . __FUNCTION__ . '.png'
 		);
 
@@ -412,5 +412,5 @@
 	public function test_wp_crop_image_url_not_exist() {
 		$file = wp_crop_image(
-			'https://asdftestblog1.files.wordpress.com/2008/04/canoladoesnotexist.jpg',
+			'https://wordpress.org/screenshots/3.9/canoladoesnotexist.jpg',
 			0,
 			0,