Index: /branches/5.0/tests/phpunit/tests/http/functions.php
===================================================================
--- /branches/5.0/tests/phpunit/tests/http/functions.php	(revision 58000)
+++ /branches/5.0/tests/phpunit/tests/http/functions.php	(revision 58001)
@@ -15,7 +15,10 @@
 	}
 
-	function test_head_request() {
-		// this url give a direct 200 response
-		$url = 'https://asdftestblog1.files.wordpress.com/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_head
+	 */
+	public function test_head_request() {
+		// This URL gives a direct 200 response.
+		$url      = 'https://s.w.org/screenshots/3.9/dashboard.png';
 		$response = wp_remote_head( $url );
 
@@ -26,12 +29,15 @@
 		$this->assertInternalType( 'array', $response );
 		
-		$this->assertEquals( 'image/jpeg', $headers['content-type'] );
-		$this->assertEquals( '40148', $headers['content-length'] );
-		$this->assertEquals( '200', wp_remote_retrieve_response_code( $response ) );
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
+		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
 
-	function test_head_redirect() {
-		// this url will 301 redirect
-		$url = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_head
+	 */
+	public function test_head_redirect() {
+		// This URL will 301 redirect.
+		$url      = 'https://wp.org/screenshots/3.9/dashboard.png';
 		$response = wp_remote_head( $url );
 
@@ -40,6 +46,9 @@
 	}
 
-	function test_head_404() {
-		$url      = 'https://asdftestblog1.files.wordpress.com/2007/09/awefasdfawef.jpg';
+	/**
+	 * @covers ::wp_remote_head
+	 */
+	public function test_head_404() {
+		$url      = 'https://wordpress.org/screenshots/3.9/awefasdfawef.jpg';
 		$response = wp_remote_head( $url );
 
@@ -48,6 +57,11 @@
 	}
 
-	function test_get_request() {
-		$url = 'https://asdftestblog1.files.wordpress.com/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_get
+	 * @covers ::wp_remote_retrieve_headers
+	 * @covers ::wp_remote_retrieve_response_code
+	 */
+	public function test_get_request() {
+		$url = 'https://s.w.org/screenshots/3.9/dashboard.png';
 
 		$response = wp_remote_get( $url );
@@ -59,13 +73,18 @@
 		$this->assertInternalType( 'array', $response );
 	
-		// should return the same headers as a head request
-		$this->assertEquals( 'image/jpeg', $headers['content-type'] );
-		$this->assertEquals( '40148', $headers['content-length'] );
-		$this->assertEquals( '200', wp_remote_retrieve_response_code( $response ) );
+		// Should return the same headers as a HEAD request.
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
+		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
 
-	function test_get_redirect() {
-		// this will redirect to asdftestblog1.files.wordpress.com
-		$url = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_get
+	 * @covers ::wp_remote_retrieve_headers
+	 * @covers ::wp_remote_retrieve_response_code
+	 */
+	public function test_get_redirect() {
+		// This will redirect to wordpress.org.
+		$url = 'https://wp.org/screenshots/3.9/dashboard.png';
 
 		$response = wp_remote_get( $url );
@@ -75,13 +94,16 @@
 		$headers = wp_remote_retrieve_headers( $response );
 
-		// should return the same headers as a head request
-		$this->assertEquals( 'image/jpeg', $headers['content-type'] );
-		$this->assertEquals( '40148', $headers['content-length'] );
-		$this->assertEquals( '200', wp_remote_retrieve_response_code( $response ) );
+		// Should return the same headers as a HEAD request.
+		$this->assertSame( 'image/png', $headers['Content-Type'] );
+		$this->assertSame( '153204', $headers['Content-Length'] );
+		$this->assertSame( 200, wp_remote_retrieve_response_code( $response ) );
 	}
 
-	function test_get_redirect_limit_exceeded() {
-		// this will redirect to asdftestblog1.files.wordpress.com
-		$url = 'https://asdftestblog1.wordpress.com/files/2007/09/2007-06-30-dsc_4700-1.jpg';
+	/**
+	 * @covers ::wp_remote_get
+	 */
+	public function test_get_redirect_limit_exceeded() {
+		// This will redirect to wordpress.org.
+		$url = 'https://wp.org/screenshots/3.9/dashboard.png';
 
 		// pretend we've already redirected 5 times
Index: /branches/5.0/tests/phpunit/tests/image/functions.php
===================================================================
--- /branches/5.0/tests/phpunit/tests/image/functions.php	(revision 58000)
+++ /branches/5.0/tests/phpunit/tests/image/functions.php	(revision 58001)
@@ -312,7 +312,7 @@
 		}
 
-		$file = wp_crop_image( 'https://asdftestblog1.files.wordpress.com/2008/04/canola.jpg',
+		$file = wp_crop_image( 'https://s.w.org/screenshots/3.9/dashboard.png',
 							  0, 0, 100, 100, 100, 100, false,
-							  DIR_TESTDATA . '/images/' . __FUNCTION__ . '.jpg' );
+							  DIR_TESTDATA . '/images/' . __FUNCTION__ . '.png' );
 		$this->assertNotInstanceOf( 'WP_Error', $file );
 		$this->assertFileExists( $file );
@@ -336,5 +336,5 @@
 		}
 
-		$file = wp_crop_image( 'https://asdftestblog1.files.wordpress.com/2008/04/canoladoesnotexist.jpg',
+		$file = wp_crop_image( 'https://wordpress.org/screenshots/3.9/canoladoesnotexist.jpg',
 							  0, 0, 100, 100, 100, 100 );
 		$this->assertInstanceOf( 'WP_Error', $file );