Index: /trunk/src/wp-includes/class-wp-customize-manager.php
===================================================================
--- /trunk/src/wp-includes/class-wp-customize-manager.php	(revision 60908)
+++ /trunk/src/wp-includes/class-wp-customize-manager.php	(revision 60909)
@@ -480,5 +480,5 @@
 			</script>
 			<?php
-			$message .= wp_get_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+			$message .= wp_get_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 		}
 
@@ -2106,5 +2106,5 @@
 		</script>
 		<?php
-		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 	}
 
@@ -2228,5 +2228,5 @@
 		</script>
 		<?php
-		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 	}
 
@@ -5023,5 +5023,5 @@
 		</script>
 		<?php
-		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+		wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 	}
 
Index: /trunk/src/wp-includes/class-wp-customize-nav-menus.php
===================================================================
--- /trunk/src/wp-includes/class-wp-customize-nav-menus.php	(revision 60908)
+++ /trunk/src/wp-includes/class-wp-customize-nav-menus.php	(revision 60909)
@@ -1557,5 +1557,5 @@
 			'navMenuInstanceArgs' => $this->preview_nav_menu_instance_args,
 		);
-		wp_print_inline_script_tag( sprintf( 'var _wpCustomizePreviewNavMenusExports = %s;', wp_json_encode( $exports, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) ) );
+		wp_print_inline_script_tag( sprintf( 'var _wpCustomizePreviewNavMenusExports = %s;', wp_json_encode( $exports, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 	}
 
Index: /trunk/src/wp-includes/class-wp-customize-widgets.php
===================================================================
--- /trunk/src/wp-includes/class-wp-customize-widgets.php	(revision 60908)
+++ /trunk/src/wp-includes/class-wp-customize-widgets.php	(revision 60909)
@@ -1336,5 +1336,5 @@
 		}
 		wp_print_inline_script_tag(
-			sprintf( 'var _wpWidgetCustomizerPreviewSettings = %s;', wp_json_encode( $settings, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) )
+			sprintf( 'var _wpWidgetCustomizerPreviewSettings = %s;', wp_json_encode( $settings, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ )
 		);
 	}
Index: /trunk/src/wp-includes/comment-template.php
===================================================================
--- /trunk/src/wp-includes/comment-template.php	(revision 60908)
+++ /trunk/src/wp-includes/comment-template.php	(revision 60909)
@@ -1375,5 +1375,5 @@
 	if ( current_user_can( 'unfiltered_html' ) ) {
 		wp_nonce_field( 'unfiltered-html-comment_' . $post_id, '_wp_unfiltered_html_comment_disabled', false );
-		wp_print_inline_script_tag( "(function(){if(window===window.parent){document.getElementById('_wp_unfiltered_html_comment_disabled').name='_wp_unfiltered_html_comment';}})();" );
+		wp_print_inline_script_tag( "(function(){if(window===window.parent){document.getElementById('_wp_unfiltered_html_comment_disabled').name='_wp_unfiltered_html_comment';}})();\n//# sourceURL=" . rawurlencode( __FUNCTION__ ) );
 	}
 }
Index: /trunk/src/wp-includes/customize/class-wp-customize-selective-refresh.php
===================================================================
--- /trunk/src/wp-includes/customize/class-wp-customize-selective-refresh.php	(revision 60908)
+++ /trunk/src/wp-includes/customize/class-wp-customize-selective-refresh.php	(revision 60909)
@@ -194,5 +194,5 @@
 
 		// Export data to JS.
-		wp_print_inline_script_tag( sprintf( 'var _customizePartialRefreshExports = %s;', wp_json_encode( $exports, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) ) );
+		wp_print_inline_script_tag( sprintf( 'var _customizePartialRefreshExports = %s;', wp_json_encode( $exports, JSON_HEX_TAG | JSON_UNESCAPED_SLASHES ) ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 	}
 
Index: /trunk/src/wp-includes/embed.php
===================================================================
--- /trunk/src/wp-includes/embed.php	(revision 60908)
+++ /trunk/src/wp-includes/embed.php	(revision 60909)
@@ -519,6 +519,7 @@
 	 * back to WordPress 4.4, so in order to not break older installs this script must come at the end.
 	 */
+	$js_path = '/js/wp-embed' . wp_scripts_get_suffix() . '.js';
 	$output .= wp_get_inline_script_tag(
-		file_get_contents( ABSPATH . WPINC . '/js/wp-embed' . wp_scripts_get_suffix() . '.js' )
+		trim( file_get_contents( ABSPATH . WPINC . $js_path ) ) . "\n//# sourceURL=" . includes_url( $js_path )
 	);
 
@@ -1091,6 +1092,7 @@
  */
 function print_embed_scripts() {
+	$js_path = '/js/wp-embed-template' . wp_scripts_get_suffix() . '.js';
 	wp_print_inline_script_tag(
-		file_get_contents( ABSPATH . WPINC . '/js/wp-embed-template' . wp_scripts_get_suffix() . '.js' )
+		trim( file_get_contents( ABSPATH . WPINC . $js_path ) ) . "\n//# sourceURL=" . includes_url( $js_path )
 	);
 }
Index: /trunk/src/wp-includes/functions.php
===================================================================
--- /trunk/src/wp-includes/functions.php	(revision 60908)
+++ /trunk/src/wp-includes/functions.php	(revision 60909)
@@ -7798,4 +7798,5 @@
 		}
 	}());
+	//# sourceURL=<?php echo rawurlencode( __FUNCTION__ ); ?>
 	</script>
 	<?php
Index: /trunk/src/wp-includes/theme.php
===================================================================
--- /trunk/src/wp-includes/theme.php	(revision 60908)
+++ /trunk/src/wp-includes/theme.php	(revision 60909)
@@ -3816,5 +3816,5 @@
 	</script>
 	<?php
-	wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+	wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __FUNCTION__ ) );
 }
 
Index: /trunk/src/wp-includes/widgets/class-wp-widget-archives.php
===================================================================
--- /trunk/src/wp-includes/widgets/class-wp-widget-archives.php	(revision 60908)
+++ /trunk/src/wp-includes/widgets/class-wp-widget-archives.php	(revision 60909)
@@ -121,5 +121,5 @@
 </script>
 			<?php
-			wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+			wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 		} else {
 			$format = current_theme_supports( 'html5', 'navigation-widgets' ) ? 'html5' : 'xhtml';
Index: /trunk/src/wp-includes/widgets/class-wp-widget-categories.php
===================================================================
--- /trunk/src/wp-includes/widgets/class-wp-widget-categories.php	(revision 60908)
+++ /trunk/src/wp-includes/widgets/class-wp-widget-categories.php	(revision 60909)
@@ -109,5 +109,5 @@
 
 			<?php
-			wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) );
+			wp_print_inline_script_tag( wp_remove_surrounding_empty_script_tags( ob_get_clean() ) . "\n//# sourceURL=" . rawurlencode( __METHOD__ ) );
 		} else {
 			$format = current_theme_supports( 'html5', 'navigation-widgets' ) ? 'html5' : 'xhtml';